/**
 * Created by Andrey on 29.09.2015.
 */

var request = require('request');
var xml2js = require('xml2js');
var _ = require('underscore');


module.exports = function(config) {

    var _baseUrl = config.baseUrl;
    var _path = '/project/all';
    var _cookies = config.cookies;

    this.getAccessibleProjects = function(params, done) {
        if (done === undefined){
            done = params;
            // default
            params = {
                verbose: false
            }
        }

        request.get(_baseUrl + _path, {
            headers: {
                "Cookie": _cookies
            },
            qs: params
        }, function (err, httpRes, body) {
            if (!err && httpRes.statusCode == 200){
                xml2js.parseString(body, function (err, result) {
                    if (!err) {
                        var projects = [];
                        _.each(result.projects.project, function (project) {
                            projects.push(project)
                        });
                        done(projects);
                    }
                });
            }
        })
    }

    return this;
};
