/**
 * Created by Andrey on 29.09.2015.
 */
var YoutrackAPI = function(config) {
    this.admin = {
        project: require('./admin/project')(config),
        user: require('./admin/user')(config),
        group: require('./admin/group')(config),
        role: require('./admin/role')(config),
        issueLinkType: require('./admin/issue-link-type')(config),
        customField: {
            field: require('./admin/custom-field/field')(config),
            bundle: require('./admin/custom-field/bundle')(config),
            type: require('./admin/custom-field/type')(config),
            ownedFieldBundle: new require('./admin/custom-field/owned-field-bundle')(config),
            buildBundle: require('./admin/custom-field/build-bundle')(config),
            stateBundle: require('./admin/custom-field/state-bundle')(config),
            versionBundle: require('./admin/custom-field/version-bundle')(config),
            userBundle: require('./admin/custom-field/user-bundle')(config)
        },
        statistics: require('./admin/statistics')(config),
        permission: require('./admin/permission')(config),
        setup: require('./admin/setup')(config)
    };
    this.issue = require('./general/issue')(config);
    this.project = require('./general/project')(config);
    this.user = require('./general/user')(config);
    this.login = require('./login')(config);
    this.export = require('./export')(config);
    this.import = require('./import')(config);
    this.agile = require('./agile')(config);

    return this;
};

module.exports = YoutrackAPI;