/**
 * Created by Andrey on 29.09.2015.
 */

var request = require('request');
var cookieParser = require('cookie');
var jsonfile = require('jsonfile');
var _ = require('underscore');
var config = require('../config');
var EventEmitter = require('events').EventEmitter;


module.exports.getCookies = function(params){

    if(params === undefined){
        params = {};
    }

    var authCookies = new EventEmitter();


    var baseUrl = params.baseUrl || config.baseUrl;
    var authPath = '/user/login';

    var login = params.login || config.login;
    var password = params.password || config.password;

    var youtrackCookiesPath = params.youtrackCookiesPath || process.cwd() + '/youtrack.cookies.json';

    // test of expires of cookie

    var cookies = [];

    jsonfile.readFile(youtrackCookiesPath, function (err, obj) {
        if (!err && obj) {
            cookies = obj;
            var expires = new Date(cookies.Expires);

            //    ,     cookie
            if (expires < Date.now()) {
                connect();
            }
            else {
                authCookies.emit('cookies', cookies);
            }
        }
        else {
            connect();
        }
    });

    function connect() {
        request.post(baseUrl + authPath, {form: {login: login, password: password}}, function (err, httpRes, body) {
            if (!err && httpRes.statusCode == 200) {
                var responseCookies = httpRes.headers['set-cookie'];

                _.each(responseCookies, function (value) {
                    cookies.push(cookieParser.parse(value));
                });

                //     
                var newCookies = {};
                _.each(cookies, function (cookie) {
                    _.extend(newCookies, cookie)
                });
                cookies = newCookies;

                if (cookies) {
                    jsonfile.writeFile(youtrackCookiesPath, cookies, function (err) {
                        if (err) throw new Error(err);
                    });
                    authCookies.emit('cookies', cookies);
                }
            }
        });
    }
    return authCookies;
};

module.exports.serialize = function (cookies) {
    var serializedCookies = '';
    _.each(cookies, function (value, key) {
        //if(key == 'Expires') {
        //    value = new Date(value);
        //}
        serializedCookies += cookieParser.serialize(key, value) + ";";
    });
    return serializedCookies;
};